#include<iostream>
#include<unordered_set>
#include<vector>
using namespace std;

const int MAXK=10;
const long long MOD=1e9+7;

long long pow7=-1;
string s[MAXK];
unordered_set<long long> st;

long long GetPow7(int k)
{
    //cout << "DEBUG GetPow7(" << k << ")\n";
    if(k==0)
    {
        return 1;
    }

    if(k%2==0)
    {
        long long p=GetPow7(k/2);

        return (p*p)%MOD;
    }

    return (29*GetPow7(k-1))%MOD;
}

long long AddHash(long long hsh, int x)
{
    //cout << "DEBUG AddHash(" << hsh << " " << x << ")" << "\n";
    hsh=(hsh*29)%MOD;
    hsh=(hsh+x)%MOD;

    return hsh;
}

long long RemoveHash(long long hsh, int x, int m)
{
    if(pow7==-1)
    {
        pow7=GetPow7(m-1);
    }
    //cout << "DEBUG RemoveHash(" << hsh << " " << x << " " << m << ")" << "\n";
    //cout << "DEBUG pow7 = " << pow7 << "\n";

    hsh=(hsh+MOD-(pow7*x)%MOD)%MOD;

    return hsh;
}

void GetSubstr(int n, int idx, int m)
{
    unordered_set<long long> subst;

    long long hsh=0;
    for(int i=0; i<m; i++)
    {
        hsh=AddHash(hsh, s[idx][i]-'a');
    }

    subst.insert(hsh);

    for(int i=1; i<n; i++)
    {
        hsh=RemoveHash(hsh, s[idx][i-1]-'a', m);
        hsh=AddHash(hsh, s[idx][(i+m-1)%n]-'a');

        subst.insert(hsh);
    }

    if(idx==0)
    {
        for(auto it=subst.begin(); it!=subst.end(); it++)
        {
            st.insert(*it);
        }
    }
    else
    {
        vector<long long> temp;
        for(auto it=st.begin(); it!=st.end();)
        {
            if(!subst.count(*it))
            {
                it=st.erase(it);
            }
            else
            {
                it++;
            }
        }
    }
}

bool IsAns(int n, int k, int m)
{
    //cout << "DEBUG m=" << m << "\n";
    st.clear();
    for(int i=0; i<k; i++)
    {
        GetSubstr(n, i, m);
    }

    return !st.empty();
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, k;
    cin >> n >> k;

    for(int i=0; i<k; i++)
    {
        cin >> s[i];
    }

    int l=1, r=n, ans=0;
    while(l<=r)
    {
        int mid=l+(r-l)/2;
        if(IsAns(n, k, mid))
        {
            ans=mid;
            l=mid+1;
        }
        else
        {
            r=mid-1;
        }
        pow7=-1;
    }

    cout << ans << "\n";

    return 0;
}
