#include<iostream>
#include<unordered_map>
#include<vector>
#include<tuple>
#include<algorithm>
using namespace std;

const int MAXN=3e5, MAXK=5;

unordered_map<string, int> nameIdx;
unordered_map<int, string> idxName;

int pts[MAXN][MAXK];

bool CompareStrings(string a, string b)
{
    int n=a.size(), m=b.size();
    for(int i=0; i<min(n, m); i++)
    {
        if(a[i]!=b[i])
        {
            return a[i]<b[i];
        }
    }

    return n<m;
}

bool CompareTuples(tuple<int, string> a, tuple<int, string> b)
{
    if(get<0>(a)!=get<0>(b))
    {
        return get<0>(a)>get<0>(b);
    }

    return CompareStrings(get<1>(a), get<1>(b));
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m, k;
    cin >> n >> m >> k;

    for(int i=0; i<n; i++)
    {
        string s;
        cin >> s;

        nameIdx[s]=i;
        idxName[i]=s;

        for(int j=0; j<MAXK; j++)
        {
            pts[i][j]=0;
        }
    }

    for(int i=0; i<m; i++)
    {
        string s;
        cin >> s;

        int idx=nameIdx[s];

        for(int j=0; j<k; j++)
        {
            int x;
            cin >> x;

            pts[idx][j]=max(pts[idx][j], x);
        }
    }

    vector<tuple<long long, string> > res;
    for(int i=0; i<n; i++)
    {
        long long x=0;
        for(int j=0; j<MAXK; j++)
        {
            x+=pts[i][j];
        }

        string s=idxName[i];

        res.push_back({x, s});
    }
    sort(res.begin(), res.end(), CompareTuples);

    for(int i=0; i<n; i++)
    {
        cout << get<1>(res[i]) << " " << get<0>(res[i]) << " ";
        int idx=nameIdx[get<1>(res[i])];
        for(int j=0; j<k; j++)
        {
            cout << pts[idx][j] << " ";
        }
        cout << "\n";
    }

    return 0;
}
