#include<iostream>
#include<vector>
#include<tuple>
#include<algorithm>
#include<stack>
using namespace std;

const int MAXN=1e5;

struct node
{
    int passLeft;
    bool visited;
};

vector<node> nodes;
vector<pair<int, int> > graph[MAXN];
stack<int> path;

bool CompareEdges(int a, int b)
{
    return graph[a].size()<graph[b].size();
}

bool EqualNodes(int idx)
{
    int m=graph[idx].size();
    if(m%2==0)
    {
        return true;
    }

    for(int i=0; i<m; i++)
    {
        int target, nodeIdx;
        tie(target, nodeIdx)=graph[idx][i];

        if(nodes[nodeIdx].passLeft!=0 && graph[target].size()%2!=0)
        {
            nodes[nodeIdx].passLeft=0;
            nodes.push_back({0, false});
            graph[idx].push_back({target, nodes.size()-1});
            graph[target].push_back({idx, nodes.size()-1});

            return EqualNodes(target);
        }
    }

    for(int i=0; i<m; i++)
    {
        int target, nodeIdx;
        tie(target, nodeIdx)=graph[idx][i];

        if(nodes[nodeIdx].passLeft!=0)
        {
            nodes[nodeIdx].passLeft=0;
            nodes.push_back({0, false});
            graph[idx].push_back({target, nodes.size()-1});
            graph[target].push_back({idx, nodes.size()-1});

            return EqualNodes(target);
        }
    }

    return false;
}

void DFS(int idx, int prNode)
{
    for(int i=0; i<graph[idx].size(); i++)
    {
        int target, nodeIdx;
        tie(target, nodeIdx)=graph[idx][i];

        if(!nodes[nodeIdx].visited)
        {
            nodes[nodeIdx].visited=true;
            DFS(target, nodeIdx);
        }
    }

    path.push(prNode);

    return;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;

    vector<int> temp;
    for(int i=0; i<n; i++)
    {
        temp.push_back(i);
    }

    for(int i=0; i<m; i++)
    {
        int a, b, t;
        cin >> a >> b >> t;
        a--, b--;

        nodes.push_back({t-1, false});
        graph[a].push_back({b, i});
        graph[b].push_back({a, i});
    }

    sort(temp.begin(), temp.end(), CompareEdges);

    for(int i=0; i<n; i++)
    {
        int idx=temp[i];
        if(graph[idx].size()%2!=0)
        {
            if(!EqualNodes(idx))
            {
                cout << "-1\n";

                return 0;
            }
        }
    }

    DFS(0, -1);
    path.pop();

    cout << path.size() << "\n";
    while(!path.empty())
    {
        cout << path.top()+1 << " ";
        path.pop();
    }

    return 0;
}
