#include<iostream>
#include<vector>
#include<tuple>
#include<algorithm>
#include<stack>
using namespace std;

const int MAXN=1e5;

struct node
{
    int passLeft;
    bool visited;
    int realIdx;
};

vector<node> nodes;
vector<pair<int, int> > graph[MAXN];
stack<int> path;
int edgeIdx[MAXN];

bool CompareEdges(int a, int b)
{
    return graph[a].size()<graph[b].size();
}

bool EqualNodes(int idx)
{
    int m=graph[idx].size();
    if(m%2==0)
    {
        return true;
    }

    for(int i=0; i<m; i++)
    {
        int target, nodeIdx;
        tie(target, nodeIdx)=graph[idx][i];

        if(nodes[nodeIdx].passLeft!=0 && graph[target].size()%2!=0)
        {
            nodes[nodeIdx].passLeft=0;
            nodes.push_back({0, false});
            graph[idx].push_back({target, nodes.size()-1});
            graph[target].push_back({idx, nodes.size()-1});

            return EqualNodes(target);
        }
    }

    for(int i=0; i<m; i++)
    {
        int target, nodeIdx;
        tie(target, nodeIdx)=graph[idx][i];

        if(nodes[nodeIdx].passLeft!=0)
        {
            nodes[nodeIdx].passLeft=0;
            nodes.push_back({0, false, nodeIdx});
            graph[idx].push_back({target, nodes.size()-1});
            graph[target].push_back({idx, nodes.size()-1});

            return EqualNodes(target);
        }
    }

    return false;
}

void DFS(int idx, int prNode)
{
    while(edgeIdx[idx]<graph[idx].size())
    {
        int target, nodeIdx;
        tie(target, nodeIdx)=graph[idx][edgeIdx[idx]];
        edgeIdx[idx]++;

        if(!nodes[nodeIdx].visited)
        {
            nodes[nodeIdx].visited=true;
            DFS(target, nodeIdx);
        }
    }

    path.push(nodes[prNode].realIdx);

    return;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;

    for(int i=0; i<n; i++)
    {
        edgeIdx[i]=0;
    }

    for(int i=0; i<m; i++)
    {
        int a, b, t;
        cin >> a >> b >> t;
        a--, b--;

        nodes.push_back({t-1, false, i});
        graph[a].push_back({b, nodes.size()-1});
        graph[b].push_back({a, nodes.size()-1});


        nodes.push_back({t-1, false, i});
        graph[a].push_back({b, nodes.size()-1});
        graph[b].push_back({a, nodes.size()-1});
    }

    DFS(0, -1);
    path.pop();

    cout << path.size() << "\n";
    while(!path.empty())
    {
        cout << path.top()+1 << " ";
        path.pop();
    }

    return 0;
}
