#include <iostream>
#include <string>
#include <map>
#define endl '\n'
using namespace std;

const int MAXN = 100000;
const int BASE = 31;
const int MOD1 = 1000000007, MOD2 = 1000000009;

int n, k;
string s[MAXN + 5];
map< pair<long long, long long>, int> mp;

bool check(int len)
{
    mp.clear();
    long long pw1 = 1, pw2 = 1;
    for (int i = 1; i <= len; ++ i)
    {
        pw1 = (pw1 * BASE) % MOD1;
        pw2 = (pw2 * BASE) % MOD2;
    }
    bool flag = false;
    for (int i = 1; i <= k; ++ i)
    {
        long long hsh1 = 0, hsh2 = 0;
        for (int j = 0; j < len; ++ j)
        {
            hsh1 = (hsh1 * BASE + (s[i][j] - 'a')) % MOD1;
            hsh2 = (hsh2 * BASE + (s[i][j] - 'a')) % MOD2;
        }
        if (i == 1) mp[{hsh1, hsh2}] = 1;
        else if (mp[{hsh1, hsh2}] == i - 1)
        {
            mp[{hsh1, hsh2}] = i;
            if (i == k) flag = true;
        }
        for (int j = len; j < 2 * n; ++ j)
        {

            hsh1 = (hsh1 * BASE + (s[i][j] - 'a')) % MOD1;
            hsh2 = (hsh2 * BASE + (s[i][j] - 'a')) % MOD2;
            hsh1 = ((hsh1 - (s[i][j - len] - 'a') * pw1) % MOD1 + MOD1) % MOD1;
            hsh2 = ((hsh2 - (s[i][j - len] - 'a') * pw2) % MOD2 + MOD2) % MOD2;
            if (i == 1) mp[{hsh1, hsh2}] = 1;
            else if (mp[{hsh1, hsh2}] == i - 1)
            {
                mp[{hsh1, hsh2}] = i;
                if (i == k) flag = true;
            }
        }
    }
    return flag;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> k;

    for (int i = 1; i <= k; ++ i)
    {
        cin >> s[i];
        s[i] += s[i];
    }

    int l = 0, r = n + 1, mid;
    while (l < r - 1)
    {
        mid = (l + r) / 2;
        if (check(mid)) l = mid;
        else r = mid;
    }

    cout << l << endl;

    return 0;
}
