#include <iostream>
#include <string>
#include <map>
#define endl '\n'
using namespace std;

const int MAXN = 100000;
const int BASE = 31;
const int MOD = 1000000007;

int n, k;
string s[MAXN + 5];
map<long long, int> mp;

bool check(int len)
{
    mp.clear();
    long long pw = 1;
    for (int i = 1; i <= len; ++ i)
    {
        pw = (pw * BASE) % MOD;
    }
    bool flag = false;
    for (int i = 1; i <= k; ++ i)
    {
        long long hsh = 0;
        for (int j = 0; j < len; ++ j)
        {
            hsh = (hsh * BASE + (s[i][j] - 'a')) % MOD;
        }
        if (i == 1) mp[hsh] = 1;
        else if (mp[hsh] == i - 1)
        {
            mp[hsh] = i;
            if (i == k) flag = true;
        }
        for (int j = len; j < 2 * n; ++ j)
        {
            hsh = (hsh * BASE + (s[i][j] - 'a')) % MOD;
            hsh = ((hsh - (s[i][j - len] - 'a') * pw) % MOD + MOD) % MOD;
            if (i == 1) mp[hsh] = 1;
            else if (mp[hsh] == i - 1)
            {
                mp[hsh] = i;
                if (i == k) flag = true;
            }
        }
    }
    return flag;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> k;

    for (int i = 1; i <= k; ++ i)
    {
        cin >> s[i];
        s[i] += s[i];
    }

    int l = 0, r = n + 1, mid;
    while (l < r - 1)
    {
        mid = (l + r) / 2;
        if (check(mid)) l = mid;
        else r = mid;
    }

    cout << l << endl;

    return 0;
}
