#include <algorithm>
#include <iostream>
#include <string>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 100000;
const int BASE = 31;
const int MOD = 1000000007;

int n, k;
bool used[16];
string s[MAXN + 5];

bool check(int len)
{
    long long pw = 1;
    for (int i = 1; i <= len; ++ i)
    {
        pw = (pw * BASE) % MOD;
    }
    vector< pair<long long, int> > v;
    for (int i = 1; i <= k; ++ i)
    {
        long long hsh = 0;
        for (int j = 0; j < len; ++ j)
        {
            hsh = (hsh * BASE + (s[i][j] - 'a')) % MOD;
        }
        v.push_back({hsh, i});
        for (int j = len; j < 2 * n; ++ j)
        {
            hsh = (hsh * BASE + (s[i][j] - 'a')) % MOD;
            hsh = ((hsh - (s[i][j - len] - 'a') * pw) % MOD + MOD) % MOD;
            v.push_back({hsh, i});
        }
    }
    sort(v.begin(), v.end());
    auto it = unique(v.begin(), v.end());
    v.resize(distance(v.begin(), it));
    long long hsh = v[0].first;
    for (int i = 0; i < v.size(); ++ i)
    {
        if (hsh == v[i].first) used[v[i].second] = true;
        else
        {
            int cnt = 0;
            for (int j = 1; j <= k; ++ j)
            {
                if (used[j]) cnt++;
                used[j] = false;
            }
            if (cnt == k) return true;
            hsh = v[i].first;
            used[v[i].second] = true;
        }
    }
    int cnt = 0;
    for (int j = 1; j <= k; ++ j)
    {
        if (used[j]) cnt++;
        used[j] = false;
    }
    if (cnt == k) return true;
    return false;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> k;

    for (int i = 1; i <= k; ++ i)
    {
        cin >> s[i];
        s[i] += s[i];
    }

    int l = 0, r = n + 1, mid;
    while (l < r - 1)
    {
        mid = (l + r) / 2;
        if (check(mid)) l = mid;
        else r = mid;
    }

    cout << l << endl;

    return 0;
}
