#include <algorithm>
#include <iostream>
#include <string>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 100000;
const int BASE = 31;
const int MOD = 1000000007;

int n, k;
bool used[16];
int pw[MAXN + 5];
string s[MAXN + 5];
int hsh[16][MAXN + 5];

bool check(int len)
{
    vector< pair<int, int> > v;
    for (int i = 1; i <= k; ++ i)
    {
        for (int j = len - 1; j < 2 * n - 1; ++ j)
        {
            int hsh0 = ((hsh[i][j + 1] - 1ll * hsh[i][j + 1 - len] * pw[len]) % MOD + MOD) % MOD;
            v.push_back({hsh0, i});
        }
    }
    sort(v.begin(), v.end());
    auto it = unique(v.begin(), v.end());
    v.resize(distance(v.begin(), it));
    int hsh = v[0].first;
    for (int i = 0; i < v.size(); ++ i)
    {
        if (hsh == v[i].first) used[v[i].second] = true;
        else
        {
            int cnt = 0;
            for (int j = 1; j <= k; ++ j)
            {
                if (used[j]) cnt++;
                used[j] = false;
            }
            if (cnt == k) return true;
            hsh = v[i].first;
            used[v[i].second] = true;
        }
    }
    int cnt = 0;
    for (int j = 1; j <= k; ++ j)
    {
        if (used[j]) cnt++;
        used[j] = false;
    }
    if (cnt == k) return true;
    return false;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> k;

    for (int i = 1; i <= k; ++ i)
    {
        cin >> s[i];
        s[i] += s[i];
    }

    pw[0] = 1;
    for (int i = 1; i <= n; ++ i)
    {
        pw[i] = (1ll * pw[i - 1] * BASE) % MOD;
    }

    for (int i = 1; i <= k; ++ i)
    {
        hsh[i][0] = 0;
        for (int j = 0; j < n; ++ j)
        {
            hsh[i][j + 1] = (1ll * hsh[i][j] * BASE + (s[i][j] - 'a')) % MOD;
        }
    }

    int l = 0, r = n + 1, mid;
    while (l < r - 1)
    {
        mid = (l + r) / 2;
        if (check(mid)) l = mid;
        else r = mid;
    }

    cout << l << endl;

    return 0;
}
