#include <algorithm>
#include <iostream>
#include <string>
#include <set>
#pragma GCC optimize ("O3,unroll-loops")
#pragma GCC target ("avx2,bmi,bmi2,lzcnt")
#define endl '\n'
using namespace std;

const int MAXN = 100000;
const int BASE = 31;
const int MOD = 1000000007;

int n, k;
int pw[MAXN + 5];
string s[MAXN + 5];
int hsh[16][MAXN + 5];

bool check(int len)
{
    set<int> active;
    for (int i = 1; i <= k; ++ i)
    {
        set<int> tmp;
        for (int j = len - 1; j < n + len - 1; ++ j)
        {
            int hsh0 = ((hsh[i][j + 1] - 1ll * hsh[i][j + 1 - len] * pw[len]) % MOD + MOD) % MOD;
            if (i == 1) tmp.insert(hsh0);
            else if (active.find(hsh0) != active.end()) tmp.insert(hsh0);
        }
        active = tmp;
    }
    if (active.size() == 0) return false;
    return true;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> k;

    for (int i = 1; i <= k; ++ i)
    {
        cin >> s[i];
        s[i] += s[i];
    }

    pw[0] = 1;
    for (int i = 1; i <= n; ++ i)
    {
        pw[i] = (1ll * pw[i - 1] * BASE) % MOD;
    }

    for (int i = 1; i <= k; ++ i)
    {
        hsh[i][0] = 0;
        for (int j = 0; j < 2 * n; ++ j)
        {
            hsh[i][j + 1] = (1ll * hsh[i][j] * BASE + (s[i][j] - 'a')) % MOD;
        }
    }

    int l = 0, r = n + 1, mid;
    while (l < r - 1)
    {
        mid = (l + r) / 2;
        if (check(mid)) l = mid;
        else r = mid;
    }

    cout << l << endl;

    return 0;
}
