#include <algorithm>
#include <iostream>
#include <utility>
#include <string>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 1000000;
const int BASE1 = 31, BASE2 = 33;
const int MOD1 = 1000000007, MOD2 = 1000000009;

int n, k;
string s[MAXN + 5];
bool used[MAXN + 5];
int pw1[MAXN + 5], pw2[MAXN + 5];
int hsh1[16][MAXN + 5], hsh2[16][MAXN + 5];

bool check(int len)
{
    vector< pair<int, int> > active;
    for (int j = len - 1; j < n + len - 1; ++ j)
    {
        int h1 = ((hsh1[1][j + 1] - 1ll * hsh1[1][j + 1 - len] * pw1[len]) % MOD1 + MOD1) % MOD1;
        int h2 = ((hsh2[1][j + 1] - 1ll * hsh2[1][j + 1 - len] * pw2[len]) % MOD2 + MOD2) % MOD2;
        active.push_back({h1, h2});
    }
    sort(active.begin(), active.end());
    auto it = unique(active.begin(), active.end());
    active.resize(distance(active.begin(), it));
    for (int i = 2; i <= k; ++ i)
    {
        for (int j = 0; j < n; ++ j)
        {
            used[j] = false;
        }
        vector< pair<int, int> > tmp;
        for (int j = len - 1; j < n + len - 1; ++ j)
        {
            int h1 = ((hsh1[i][j + 1] - 1ll * hsh1[i][j + 1 - len] * pw1[len]) % MOD1 + MOD1) % MOD1;
            int h2 = ((hsh2[i][j + 1] - 1ll * hsh2[i][j + 1 - len] * pw2[len]) % MOD2 + MOD2) % MOD2;
            int p = lower_bound(active.begin(), active.end(), make_pair(h1, h2)) - active.begin();
            if (p < active.size() and active[p] == make_pair(h1, h2) and !used[p])
            {
                used[p] = true;
                tmp.push_back(make_pair(h1, h2));
            }
        }
        sort(tmp.begin(), tmp.end());
        active = tmp;
        if (active.size() == 0) return false;
    }
    return true;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> k;

    for (int i = 1; i <= k; ++ i)
    {
        cin >> s[i];
        s[i] += s[i];
    }

    pw1[0] = pw2[0] = 1;
    for (int i = 1; i <= n; ++ i)
    {
        pw1[i] = (1ll * pw1[i - 1] * BASE1) % MOD1;
        pw2[i] = (1ll * pw2[i - 1] * BASE2) % MOD2;
    }

    for (int i = 1; i <= k; ++ i)
    {
        hsh1[i][0] = hsh2[i][0] = 0;
        for (int j = 0; j < 2 * n; ++ j)
        {
            hsh1[i][j + 1] = (1ll * hsh1[i][j] * BASE1 + (s[i][j] - 'a')) % MOD1;
            hsh2[i][j + 1] = (1ll * hsh2[i][j] * BASE2 + (s[i][j] - 'a')) % MOD2;
        }
    }

    int l = 0, r = n + 1, mid;
    while (l < r - 1)
    {
        mid = (l + r) / 2;
        if (check(mid)) l = mid;
        else r = mid;
    }

    cout << l << endl;

    return 0;
}
