#include <algorithm>
#include <iostream>
#include <string>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 1000000;
const int BASE = 31;
const int MOD = 1000000009;

int n, k;
int pw[MAXN + 5];
string s[MAXN + 5];
bool used[MAXN + 5];
int hsh[16][MAXN + 5];

bool check(int len)
{
    vector<int> active;
    for (int j = len - 1; j < n + len - 1; ++ j)
    {
        int hsh0 = ((hsh[1][j + 1] - 1ll * hsh[1][j + 1 - len] * pw[len]) % MOD + MOD) % MOD;
        active.push_back(hsh0);
    }
    sort(active.begin(), active.end());
    auto it = unique(active.begin(), active.end());
    active.resize(distance(active.begin(), it));
    for (int i = 2; i <= k; ++ i)
    {
        for (int j = 0; j < n; ++ j)
        {
            used[j] = false;
        }
        vector<int> tmp;
        for (int j = len - 1; j < n + len - 1; ++ j)
        {
            int hsh0 = ((hsh[i][j + 1] - 1ll * hsh[i][j + 1 - len] * pw[len]) % MOD + MOD) % MOD;
            int p = lower_bound(active.begin(), active.end(), hsh0) - active.begin();
            if (p < active.size() and active[p] == hsh0 and !used[p])
            {
                used[p] = true;
                tmp.push_back(hsh0);
            }
        }
        sort(tmp.begin(), tmp.end());
        active = tmp;
        if (active.size() == 0) return false;
    }
    return true;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> k;

    for (int i = 1; i <= k; ++ i)
    {
        cin >> s[i];
        s[i] += s[i];
    }

    pw[0] = 1;
    for (int i = 1; i <= n; ++ i)
    {
        pw[i] = (1ll * pw[i - 1] * BASE) % MOD;
    }

    for (int i = 1; i <= k; ++ i)
    {
        hsh[i][0] = 0;
        for (int j = 0; j < 2 * n; ++ j)
        {
            hsh[i][j + 1] = (1ll * hsh[i][j] * BASE + (s[i][j] - 'a')) % MOD;
        }
    }

    int l = 0, r = n + 1, mid;
    while (l < r - 1)
    {
        mid = (l + r) / 2;
        if (check(mid)) l = mid;
        else r = mid;
    }

    cout << l << endl;

    return 0;
}
