#include <algorithm>
#include <iostream>
#include <string>
#define endl '\n'
using namespace std;

const int MAXN = 250000;

struct person
{
    string name;
    int pts[8];
    long long total;
};

person people[MAXN + 5];
person submit[MAXN + 5];

bool cmp(person x, person y)
{
    if (x.total != y.total) return (x.total > y.total);
    int a = x.name.size(), b = y.name.size();
    for (int i = 0; i < min(a, b); ++ i)
    {
        if (x.name[i] != y.name[i]) return (x.name[i] < y.name[i]);
    }
    return (a > b);
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n, m, k;
    cin >> n >> m >> k;

    for (int i = 1; i <= n; ++ i)
    {
        cin >> people[i].name;
    }

    sort(people + 1, people + n + 1, cmp);

    for (int i = 1; i <= m; ++ i)
    {
        cin >> submit[i].name;
        for (int j = 1; j <= k; ++ j)
        {
            cin >> submit[i].pts[j];
        }
    }

    sort(submit + 1, submit + m + 1, cmp);

    int idx = 1;
    for (int i = 1; i <= m; ++ i)
    {
        while (people[idx].name != submit[i].name) idx++;
        int sum = 0;
        for (int j = 1; j <= k; ++ j)
        {
            people[idx].pts[j] = max(people[idx].pts[j], submit[i].pts[j]);
            sum += people[idx].pts[j];
        }
        people[idx].total = sum;
    }

    sort(people + 1, people + n + 1, cmp);

    for (int i = 1; i <= n; ++ i)
    {
        cout << people[i].name << " " << people[i].total;
        for (int j = 1; j <= k; ++ j)
        {
            cout << " " << people[i].pts[j];
        }
        cout << endl;
    }

    return 0;
}
