#include <iostream>
#include <utility>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 100000;
const int MAXM = 1000000;

bool used1[MAXN + 5];
bool used2[MAXM + 5];
vector< pair<int, int> > cycles[MAXN + 5];
vector< pair<int, int> > G[MAXN + 5];

void print(int u)
{
    used1[u] = true;
    for (auto [v, t] : cycles[u])
    {
        cout << t << " ";
        if (!used1[v]) print(v);
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n, m;
    cin >> n >> m;

    for (int i = 1; i <= m; ++ i)
    {
        int u, v, t;
        cin >> u >> v >> t;
        G[u].push_back({v, i});
        G[v].push_back({u, i});
    }

    for (int i = 1; i <= n; ++ i)
    {
        if (G[i].size() % 2)
        {
            cout << -1 << endl;
            return 0;
        }
    }

    cout << m << endl;

    for (int i = 1; i <= n; ++ i)
    {
        while (G[i].size())
        {
            while (G[i].size() and used2[G[i][0].second]) G[i].erase(G[i].begin());
            if (!G[i].size()) break;
            int u = i;
            do
            {
                int v = G[u][0].first;
                used2[G[u][0].second] = true;
                cycles[i].push_back(G[u][0]);
                G[u].erase(G[u].begin());
                u = v;
                while (G[u].size() and used2[G[u][0].second]) G[u].erase(G[u].begin());
            } while (u != i);
        }
    }

    print(1);
    cout << endl;

    return 0;
}
