#include <algorithm>
#include <iostream>
#include <utility>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 100000;
const int MAXM = 1000000;

bool used[MAXN + 5];
vector< pair<int, int> > G[MAXN + 5];
vector< pair<int, int> > cycles[MAXN + 5];

void print(int u)
{
    used[u] = true;
    for (auto [v, t] : cycles[u])
    {
        cout << t << " ";
        if (!used[v]) print(v);
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n, m;
    cin >> n >> m;

    for (int i = 1; i <= m; ++ i)
    {
        int u, v, t;
        cin >> u >> v >> t;
        G[u].push_back({v, i});
        G[v].push_back({u, i});
    }

    for (int i = 1; i <= n; ++ i)
    {
        sort(G[i].begin(), G[i].end());
        if (G[i].size() % 2)
        {
            cout << -1 << endl;
            return 0;
        }
    }

    cout << m << endl;

    for (int i = 1; i <= n; ++ i)
    {
        int u = i;
        do
        {
            int v = G[u][0].first, t = G[u][0].second;
            cycles[i].push_back(G[u][0]);
            G[u].erase(G[u].begin());
            auto it = lower_bound(G[v].begin(), G[v].end(), make_pair(u, t));
            G[v].erase(it);
            u = v;
        } while (G[u].size());
    }

    print(1);
    cout << endl;

    return 0;
}
