#include <algorithm>
#include <iostream>
#include <utility>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 100000;
const int MAXM = 1000000;

typedef vector< pair<int, int> > :: iterator itv;

bool used[MAXN + 5];
vector< pair<int, int> > G[MAXN + 5];
vector< pair<int, int> > cycles[MAXN + 5];
pair< pair<int, itv>, pair<int, itv> > it[MAXM + 5];

void print(int u)
{
    used[u] = true;
    for (auto [v, t] : cycles[u])
    {
        cout << t << " ";
        if (!used[v]) print(v);
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n, m;
    cin >> n >> m;

    for (int i = 1; i <= m; ++ i)
    {
        int u, v, t;
        cin >> u >> v >> t;
        G[u].push_back({v, i});
        G[v].push_back({u, i});
        it[i] = make_pair(make_pair(u, G[u].end() - 1), make_pair(v, G[v].end() - 1));
    }

    for (int i = 1; i <= n; ++ i)
    {
        if (G[i].size() % 2)
        {
            cout << -1 << endl;
            return 0;
        }
    }

    cout << m << endl;

    for (int i = 1; i <= n; ++ i)
    {
        int u = i;
        while (G[u].size())
        {
            int v = G[u][0].first, t = G[u][0].second;
            cycles[i].push_back(G[u][0]);
            if (u == it[t].first.first)
            {
                G[u].erase(it[t].first.second);
                G[v].erase(it[t].second.second);
            }
            else
            {
                G[u].erase(it[t].second.second);
                G[v].erase(it[t].first.second);
            }
            u = v;
        }
    }

    print(1);
    cout << endl;

    return 0;
}
