#include <algorithm>
#include <iostream>
#include <utility>
#include <vector>
#include <queue>
#define endl '\n'
using namespace std;

const int MAXN = 1000000;
const int MAXM = 10000000;

int n, m;
int pos[MAXN + 5];
bool used1[MAXN + 5];
bool used2[2 * MAXM + 5];
vector< pair<int, int> > cycles[MAXN + 5];
vector< pair<int, int> > G[MAXN + 5], G1[MAXN + 5];

void print(int u)
{
    used1[u] = true;
    for (auto [v, t] : cycles[u])
    {
        if (t <= m) cout << t << " ";
        else cout << t - m << " ";
        if (!used1[v]) print(v);
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> m;
    
    bool flag = true;
    for (int i = 1; i <= m; ++ i)
    {
        int u, v, t;
        cin >> u >> v >> t;
        if (t == 1) flag = false;
        G[u].push_back({v, i});
        G[u].push_back({v, i + m});
        G[v].push_back({u, i});
        G[v].push_back({u, i + m});
        G1[u].push_back({v, i});
        G1[v].push_back({u, i});
    }
    
    if (!flag)
    {
        for (int i = 1; i <= n; ++ i)
        {
            if (G1[u].size() % 2)
            {
                cout << -1 << endl;
                return 0;
            }
        }
    }

    cout << 2 * m << endl;

    queue<int> q;
    q.push(1);
    while (!q.empty())
    {
        int u0 = q.front();
        q.pop();
        int u = u0;
        while (pos[u] < G[u].size() and used2[G[u][pos[u]].second]) pos[u]++;
        while (pos[u] < G[u].size())
        {
            cycles[u0].push_back(G[u][pos[u]]);
            used2[G[u][pos[u]].second] = true;
            u = G[u][pos[u]].first;
            q.push(u);
            while (pos[u] < G[u].size() and used2[G[u][pos[u]].second]) pos[u]++;
        }
    }

    print(1);
    cout << endl;

    return 0;
}
