#include <algorithm>
#include <iostream>
#include <utility>
#include <vector>
#include <queue>
#define endl '\n'
using namespace std;

const int MAXN = 100000;
const int MAXM = 1000000;

int n, m;
int pos[MAXN + 5];
bool used[MAXN + 5];
bool used1[MAXN + 5];
bool used2[2 * MAXM + 5];
pair<int, int> par[MAXN + 5];
vector< pair<int, int> > G[MAXN + 5];
vector< pair<int, int> > G1[MAXN + 5];
vector< pair<int, int> > cycles[MAXN + 5];

void DFS(int u)
{
    used[u] = true;
    for (auto [v, t] : G1[u])
    {
        if (!used[v])
        {
            par[v] = {u, t};
            DFS(v);
        }
    }
}

void print(int u)
{
    used1[u] = true;
    for (auto [v, t] : cycles[u])
    {
        if (t <= m) cout << t << " ";
        else cout << t - m << " ";
        if (!used1[v]) print(v);
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> m;

    for (int i = 1; i <= m; ++ i)
    {
        int u, v, t;
        cin >> u >> v >> t;
        G[u].push_back({v, i});
        G[v].push_back({u, i});
        if (t == 2)
        {
            G1[u].push_back({v, i});
            G1[v].push_back({u, i});
        }
    }

    int add = 0, u = 0, v = 0;
    for (int i = 1; i <= n; ++ i)
    {
        if (G[i].size() % 2)
        {
            if (u == 0) u = i;
            else v = i;
        }
    }

    if (u != 0)
    {
        DFS(u);
        if (par[v].first == 0)
        {
            cout << -1 << endl;
            return 0;
        }
        while (v != u)
        {
            add++;
            G[v].push_back({par[v].first, par[v].second + m});
            G[par[v].first].push_back({v, par[v].second + m});
            v = par[v].first;
        }
    }

    cout << m + add << endl;

    queue<int> q;
    q.push(1);
    while (!q.empty())
    {
        int u0 = q.front();
        q.pop();
        int u = u0;
        while (pos[u] < G[u].size() and used2[G[u][pos[u]].second]) pos[u]++;
        while (pos[u] < G[u].size())
        {
            cycles[u0].push_back(G[u][pos[u]]);
            used2[G[u][pos[u]].second] = true;
            u = G[u][pos[u]].first;
            q.push(u);
            while (pos[u] < G[u].size() and used2[G[u][pos[u]].second]) pos[u]++;
        }
    }

    print(1);
    cout << endl;

    return 0;
}
