#include <algorithm>
#include <iostream>
#include <utility>
#include <vector>
#include <queue>
#define endl '\n'
using namespace std;

const int MAXN = 100000;
const int MAXM = 1000000;

int n, m, ans;
int pos[MAXN + 5];
bool used1[MAXN + 5];
bool marked[MAXN + 5];
bool used2[2 * MAXM + 5];
vector< pair<int, int> > G[MAXN + 5];
vector< pair<int, int> > G1[MAXN + 5];
vector< pair<int, int> > cycles[MAXN + 5];

int DFS(int u)
{
    int cnt = 0;
    used1[u] = true;
    if (marked[u]) cnt++;
    for (auto [v, t] : G1[u])
    {
        if (!used1[v])
        {
            int tmp = DFS(v);
            if (tmp % 2)
            {
                ans++;
                cnt += tmp;
                G[u].push_back({v, m + t});
                G[v].push_back({u, m + t});
            }
        }
    }
    return cnt;
}

void print(int u)
{
    used1[u] = true;
    for (auto [v, t] : cycles[u])
    {
        if (t <= m) cout << t << " ";
        else cout << t - m << " ";
        if (!used1[v]) print(v);
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> m;

    ans = m;
    for (int i = 1; i <= m; ++ i)
    {
        int u, v, t;
        cin >> u >> v >> t;
        G[u].push_back({v, i});
        G[v].push_back({u, i});
        if (t == 2)
        {
            G1[u].push_back({v, i});
            G1[v].push_back({u, i});
        }
    }

    for (int i = 1; i <= n; ++ i)
    {
        if (G[i].size() % 2) marked[i] = true;
    }

    for (int i = 1; i <= n; ++ i)
    {
        if (!used1[i])
        {
            if (DFS(i) % 2)
            {
                cout << -1 << endl;
                return 0;
            }
        }
    }

    cout << ans << endl;

    queue<int> q;
    q.push(1);
    while (!q.empty())
    {
        int u0 = q.front();
        q.pop();
        int u = u0;
        while (pos[u] < G[u].size() and used2[G[u][pos[u]].second]) pos[u]++;
        while (pos[u] < G[u].size())
        {
            cycles[u0].push_back(G[u][pos[u]]);
            used2[G[u][pos[u]].second] = true;
            u = G[u][pos[u]].first;
            q.push(u);
            while (pos[u] < G[u].size() and used2[G[u][pos[u]].second]) pos[u]++;
        }
    }

    for (int i = 1; i <= n; ++ i)
    {
        used1[i] = false;
    }

    print(1);
    cout << endl;

    return 0;
}
