#include<iostream>
#include<math.h>
#include<algorithm>
#include<map>

using namespace std;

class Competitor
{
public:
    void Initialise()
    {
        for(long long i = 0;i < 6;i++)
        {
            points[i] = 0;
        }
    }

    long long totalPoints = 0;

    string name;

    long long points[6];

    void SetPoints(long long index, long long p)
    {
        if(points[index] < p)
        {
            totalPoints -= points[index];

            points[index] = p;

            totalPoints += points[index];
        }
    }
};

bool Compare(Competitor a, Competitor b)
{
    if(a.totalPoints != b.totalPoints)
    {
        return a.totalPoints > b.totalPoints;
    }

    return a.name < b.name;
}

map<string, Competitor> a;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    a.value_comp();

    long long n,m,k;

    cin>>n>>m>>k;

    for(long long i = 0;i < n;i++)
    {
        Competitor c;

        cin>>c.name;

        c.Initialise();

        a[c.name] = c;
    }

    for(long long i = 0;i < m;i++)
    {
        string name;
        cin>>name;

        long long newPoints[k];

        for(long long j = 0;j < k;j++)
        {
            cin>>newPoints[j];
            a[name].SetPoints(j, newPoints[j]);
        }
    }

    Competitor cp[n];

    long long index = 0;

    for (auto&& [first,second] : a) {
        cp[index] = second;
        index++;
    }

    sort(cp, cp + n, Compare);

    for(long long i = 0;i < n;i++)
    {
        cout<<cp[i].name<<" "<<cp[i].totalPoints;

        for(long long j = 0;j < k;j++)
        {
            cout<<" "<<cp[i].points[j];
        }

        cout<<endl;
    }
}
