#include <bits/stdc++.h>
#pragma GCC optimize("O3")

typedef long long ll;
const int MAX_N = 4e5 + 10;
const int MAX_LOG = 16;

int n, k;
std::string name[MAX_N];

std::string full;
int pos_cor[MAX_N];
int ind[MAX_LOG][MAX_N];
int suf_arr[MAX_N];
int lcp[MAX_N];
int howm[MAX_N];

int find_lcp(int a, int b) {
    int cnt = 0;
    for(int i = MAX_LOG - 1; i >= 0; i --) {
        if(std::max(a, b) + (1 << i) < full.size() && ind[i][a] == ind[i][b]) {
            cnt += (1 << i);
            a += (1 << i);
            b += (1 << i);
        }
    }
    return cnt;
}

void construct() {
    for(int i = 0; i < full.size(); i ++) {
        ind[0][i] = full[i];
    }

    for(int i = 1; i < MAX_LOG; i ++) {
        std::vector<std::pair<std::pair<int, int>, int> > slice;
        for(int j = 0; j < full.size(); j ++) {
            if(j + (1 << i) < full.size()) {
                slice.push_back({{ind[i - 1][j], ind[i - 1][j + (1 << (i - 1))]}, j});
            } else {
                slice.push_back({{ind[i - 1][j], -1}, j});
            }
        }
        std::sort(slice.begin(), slice.end());

        int tme = 0;
        for(int j = 0; j < full.size(); j ++) {
            if(j != 0 && slice[j].first != slice[j - 1].first) {
                tme ++;
            }
            ind[i][slice[j].second] = tme;
        }
    }

    std::vector<std::pair<int, int> > helper(full.size());
    for(int i = 0; i < full.size(); i ++) {
        helper[i] = {ind[MAX_LOG - 1][i], i};
    }
    std::sort(helper.begin(), helper.end());

    for(int i = 0; i < full.size(); i ++) {
        suf_arr[i] = helper[i].second;
    }

    for(int i = 1; i < full.size(); i ++) {
        lcp[i] = std::min(find_lcp(suf_arr[i], suf_arr[i - 1]), std::min(howm[suf_arr[i]], howm[suf_arr[i - 1]]));
    }
}

int on[MAX_N];
int cnt_on = 0;

void zero() {
    for(int i = 0; i < k; i ++) {
        on[i] = false;
    }
    cnt_on = 0;
}

void insert(int ind) {
    if(!on[ind]) {
        cnt_on ++;
    }
    on[ind] = true;
}

bool pos(int cnt) {
    if(cnt > n) {
        return false;
    }

    for(int i = 0; i < full.size(); i ++) {
        if(i == 0 || lcp[i] < cnt) {
            zero();
        }

        insert(pos_cor[suf_arr[i]]);
        if(cnt_on == k) {
            return true;
        }
    }
    return false;
}

signed main() {
    std::ios_base::sync_with_stdio(false); std::cin.tie(NULL);

    std::cin >> n >> k;
    for(int i = 0; i < k; i ++) {
        std::cin >> name[i];

        for(int j = 0; j < n; j ++) {
            pos_cor[full.size()] = i;
            full.push_back(name[i][j]);
        }
        for(int j = 0; j < n; j ++) {
            pos_cor[full.size()] = i;
            full.push_back(name[i][j]);
        }
        pos_cor[full.size()] = i;
        full.push_back('$');
    }

    int last;
    for(int i = full.size() - 1; i >= 0; i --) {
        if(full[i] == '$') {
            last = i;
        }
        howm[i] = last - i;
    }

    construct();

    int l = 0, r = n + 1;
    while(l < r - 1) {
         int m = (l + r) / 2ll;
         if(pos(m)) {
            l = m;
         } else {
            r = m;
         }
    }

    std::cout << l << std::endl;

    return 0;
}


