#include <bits/stdc++.h>

const int MAX_N = 1e6 + 10;
const int MAX_LOG = 20;

struct dsu {
    int par[MAX_N];
    int sz[MAX_N];

    dsu() {
        for(int i = 0; i < MAX_N; i ++) {
            par[i] = i;
            sz[i] = 1;
        }
    }

    int find(int x) {
        if(x == par[x]) {
            return x;
        } else {
            return par[x] = find(par[x]);
        }
    }

    bool merge(int a, int b) {
        a = find(a); b = find(b);
        if(a == b) { return false; }
        if(sz[a] < sz[b]) { std::swap(a, b); }
        par[b] = a;
        sz[a] += sz[b];
        return true;
    }
} conn;

std::vector<std::pair<int, int> > g[MAX_N];
std::pair<std::pair<int, int>, int> add[MAX_N];
std::vector<std::pair<int, int> > tree[MAX_N];
int n, m;
int par[MAX_N][MAX_LOG];
int d[MAX_N];

void prec(int x, int p) {
    par[x][0] = p;
    d[x] = d[p] + 1;
    for(int i = 1; i < MAX_LOG; i ++) {
        par[x][i] = par[par[x][i - 1]][i - 1];
    }

    for(const auto &it : tree[x]) {
        if(it.first == p) { continue; }
        prec(it.first, x);
    }
}

int start[MAX_N];

int dfs2(int x, int p) {
    int cnt = start[x];

    for(const auto &it : tree[x]) {
        if(it.first == p) { continue; }
        int howm = dfs2(it.first, x);
        if(howm & 1) {
            if(it.second != -1) {
                int a = add[it.second].first.first;
                int b = add[it.second].first.second;
                g[a].push_back({b, m + it.second});
                g[b].push_back({a, m + it.second});
            }
        }
        cnt += howm;
    }

    return cnt;
}

void transform() {
    // cout << "esiza alave" << endl;

    for(const auto &it : add) {
        if(conn.merge(it.first.first, it.first.second)) {
            tree[it.first.first].push_back({it.first.second, it.second});
            tree[it.first.second].push_back({it.first.first, it.second});
        }
    }

    std::vector<int> odd;

    for(int i = 1; i <= n; i ++) {
        if(conn.find(i) == i) {
            tree[0].push_back({i, -1});
        }
        if(g[i].size() & 1) {
            odd.push_back(i);
        }
    }

    prec(0, -1);

    assert(odd.size() % 2 == 0);
    for(int i = 0; i < odd.size(); i ++) {
        start[odd[i]] ++;
    }

    dfs2(0, -1);
}

std::vector<int> path;
bool used[MAX_N];
int pind[MAX_N];

void dfs(int x) {
    for(; pind[x] < g[x].size(); pind[x] ++) {
        const auto &it = g[x][pind[x]];
        if(used[it.second]) { continue; }
        used[it.second] = true;
        dfs(it.first);
        path.push_back(it.second);
    }
}

void printAns() {
    for(int i = 1; i <= n; i ++) {
        if(g[i].size() & 1) {
            std::cout << -1 << std::endl;
            return;
        }
    }

    dfs(1);

    std::cout << path.size() << std::endl;
    for(const auto it : path) {
        std::cout << it % m + 1 << " ";
    }
    std::cout << std::endl;
}

signed main() {
    std::cin >> n >> m;

    for(int i = 0; i < m; i ++) {
        int a, b, c;
        std::cin >> a >> b >> c;
        g[a].push_back({b, i});
        g[b].push_back({a, i});
        if(c == 2) {
            add[i] = {{a, b}, i};
        }
    }

    transform();
    printAns();
}
