#include <iostream>
#include <vector>
#include <stack>
using namespace std;
const int MAXN=1e5+10;
const int MAXM=1e6+10;
vector <pair <int,int> > v[2][MAXN];
vector <pair <int,int> > ver[MAXN];
stack <int> st;
int cnt[MAXN], comp[MAXN], curbr;
int used[MAXM], gr[MAXM];
int n, m;
void add_edge(int a, int b, int ind, int fl) {
    v[fl][a].push_back({b,ind});
    v[fl][b].push_back({a,ind});
}
void dfs (int x) {
    comp[x]=curbr;
    for (auto i:v[1][x]) {
        if (comp[i.first]!=0) continue;
        dfs(i.first);
    }
}
void transform_graph() {
    for (int i=1;i<=n;i++) {
        for (auto j:v[0][i]) {
            ver[i].push_back(j);
            gr[j.second]=1;
        }
        for (auto j:v[1][i]) {
            ver[i].push_back(j);
            gr[j.second]=2;
        }
    }
}
void euler(int x) {
    for (auto i:ver[x]) {
        if (used[i.second]==gr[i.second]) continue;
        used[i.second]++;
        euler(i.first);
        st.push(i.second);
    }
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int a, b, fl;
    cin >> n >> m;
    for (int i=1;i<=m;i++) {
        cin >> a >> b >> fl;
        add_edge(a,b,i,0);
        if (fl==2) {
            add_edge(a,b,i,1);
        }
    }
    curbr=1;
    for (int i=1;i<=n;i++) {
        if (comp[i]==0) {
            comp[i]=curbr;
            dfs(i);
            curbr++;
        }
    }
    for (int i=1;i<=n;i++) {
        if (v[0][i].size()%2==1) cnt[comp[i]]++;
    }
    bool one=false;
    int c=0;
    for (int i=1;i<curbr;i++) {
        if (cnt[i]%2==1) {
            c++;
            if (i==1) one=true;
        }
    }
    if (!(c==0 || (c==2 && one))) {
        cout << -1 << endl;
        return 0;
    }
    transform_graph();
    euler(1);
    cout << st.size() << endl;
    while (!st.empty()) {
        cout << st.top() << ' ';
        st.pop();
    }
    return 0;
}
/**
10 18
1 10 1
7 9 2
2 6 1
3 7 1
3 8 1
9 2 2
2 8 2
4 2 1
4 6 1
6 8 1
3 6 1
1 9 1
4 9 1
10 7 2
7 5 2
5 3 1
4 7 1
10 5 1
**/
