#include <iostream>
#include <vector>

#define endl '\n'

using namespace std;

const int MAXN = 1e5 + 3;
const int MAXM = 1e6 + 3;

struct Edge
{
    int to, type, idx;

    Edge(int _to, int _type, int _idx)
    {
        to = _to;
        type = _type;
        idx = _idx;
    }
};

vector<Edge> graph[MAXN];
int in_degree[MAXN];
bool is_edge_visited[MAXM];

void dfs(int currv, vector<int>& res)
{
    for (Edge& edge : graph[currv])
    {
        if (!is_edge_visited[edge.idx])
        {
            is_edge_visited[edge.idx] = true;
            res.push_back(edge.idx);

            dfs(edge.to, res);
        }
    }
}

void find_path(int n, int m)
{
    for (int i = 0; i < n; ++i) {
        if (in_degree[i] % 2 == 1)
        {
            cout << -1 << endl;
            return;
        }
    }

    vector<int> res;
    dfs(0, res);

    cout << (int) res.size() << endl;
    for (int curr_idx : res)
    {
        cout << curr_idx + 1 << " ";
    }
    cout << endl;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;

    for (int i = 0; i < m; ++i)
    {
        int from, to, type;
        cin >> from >> to >> type;

        --from;
        --to;

        graph[from].push_back(Edge(to, type, i));
        graph[to].push_back(Edge(from, type, i));

        ++in_degree[from];
        ++in_degree[to];
    }

    find_path(n, m);

    return 0;
}
