#include<iostream>
#include<string>
#include<map>
#include<unordered_map>
using namespace std;

const long long base = 257;
const long long mod = 1000000007;

int daljina;
int n;

string s[11];

long long basePow[11][200010];
long long prefixHash[11][200010];

void precalc(int idx){

    basePow[idx][0] = 1;

    for(int i = 1; i < s[idx].size(); i++){
        basePow[idx][i] = (basePow[idx][i - 1]*base)%mod;
    }

    prefixHash[idx][0] = s[idx][0];

    for(int i = 1; i < s[idx].size(); i++){
        prefixHash[idx][i] = (prefixHash[idx][i - 1]*base + s[idx][i] + mod)%mod;
    }

}

long long daiHash(int idx, int lqvo, int dqsno){

    long long h1 = prefixHash[idx][dqsno];
    long long h2 = 0;
    if(lqvo > 0){
        h2 = prefixHash[idx][lqvo - 1];
    }

    h2 = (h2*basePow[idx][dqsno - lqvo + 1])%mod;

    return (h1 - h2 + mod)%mod;
}

unordered_map<long long, int> vavKolkoGoIma;
unordered_map<long long, bool> vToziImaLiGo;

bool sTakavaDaljina(int kakvaDalj){

    vavKolkoGoIma.clear();
    vToziImaLiGo.clear();

    //cout<<"daljina "<<kakvaDalj<<endl;

    for(int i = 0; i < daljina; i++){
        //string tuka = s[0].substr(i, kakvaDalj);
        long long tuka = daiHash(0, i, i + kakvaDalj - 1);

        if(vToziImaLiGo[tuka] == false){
            vavKolkoGoIma[tuka]++;
            vToziImaLiGo[tuka] = true;
        }
    }
    vToziImaLiGo.clear();

    bool stavaLi = true;

    for(int k = 1; k < n; k++){

        bool tukaImaLi = false;

        for(int i = 0; i < daljina; i++){
            //string tuka = s[k].substr(i, kakvaDalj);
            long long tuka = daiHash(k, i, i + kakvaDalj - 1);

            if(vToziImaLiGo[tuka] == false){
                vToziImaLiGo[tuka] = true;
                if(vavKolkoGoIma[tuka] == k){
                    vavKolkoGoIma[tuka]++;
                    tukaImaLi = true;
                }
            }
        }

        if(tukaImaLi == false){
            stavaLi = false;
            break;
        }

        vToziImaLiGo.clear();
    }

    return stavaLi;

    /*
    for(unordered_map<string, int>::iterator i = kolkoGoIma.begin(); i != kolkoGoIma.end(); i++){
        //cout<<i->first<<" "<<i->second<<endl;
        if(i->second == n){
            return true;
        }
    }
    */

    /*
    if(kolkoGoIma.size() > 0){
        return true;
    }

    return false;
    */

    /*
    for(int i = 0; i < daljina; i++){
        string tuka = s[0].substr(i, kakvaDalj);

        bool stavaLi = true;

        for(int k = 1; k < n; k++){

            bool tekushto = false;

            for(int j = 0; j < daljina; j++){
                string drugiq = s[k].substr(j, kakvaDalj);

                if(tuka == drugiq){
                    tekushto = true;
                    break;
                }
            }

            if(tekushto == false){
                stavaLi = false;
                break;
            }
        }

        if(stavaLi == true){
            return true;
        }
    }

    return false;
    */
}

int main(){

    cin>>daljina>>n;

    for(int i = 0; i < n; i++){
        cin>>s[i];
    }

    for(int i = 0; i < n; i++){
        for(int j = 0; j < daljina - 1; j++){
            s[i] += s[i][j];
        }
    }

    for(int i = 0; i < n; i++){
        precalc(i);
    }

    /*int otg = 0;

    for(int i = 1; i <= daljina; i++){
        bool tuka = sTakavaDaljina(i);

        if(tuka == true){
            otg = i;
        }else{
            break;
        }
    }*/


    int lqvKrai = 0;
    int desenKrai = daljina;

    while(lqvKrai + 1 < desenKrai){
        int sredata = (lqvKrai + desenKrai)/2;

        if(sTakavaDaljina(sredata) == true){
            lqvKrai = sredata + 1;
        }else{
            desenKrai = sredata;
        }
    }

    if(sTakavaDaljina(lqvKrai) == false){
        lqvKrai--;
    }

    cout<<lqvKrai<<endl;


    //cout<<otg<<endl;

    return 0;
}
