#include<bits/stdc++.h>
#define ll long long
#define de(x) cout << #x << " = " << x << endl;
#define endl '\n'
using namespace std;

const int CNT_HASHES = 1;
const int MODS[] = {1000000007, 1000000009};
const int BASE[] = {37, 53};
const int MAXN = 2e5 + 5;

ll N, K, pows[CNT_HASHES][MAXN + 5];

struct Hash{
    int sz = 0;
    string t;
    vector<vector<ll>> h;
    Hash() {}
    Hash(string _t){
        t = _t;
        sz = t.size();
        h.resize(CNT_HASHES);
        for(int i = 0; i < CNT_HASHES; i ++){
            h[i].resize(sz);
            for(int j = 0; j < sz; j ++){
                h[i][j] = ((j ? h[i][j - 1] : 0) + ((t[j] - 'a' + 1) * pows[i][j]) % MODS[i]) % MODS[i];
            }
        }
    }
    vector<ll> get(int l, int r){
        vector<ll> ret(CNT_HASHES);
        for(int i = 0; i < CNT_HASHES; i ++){
            ret[i] = (pows[i][MAXN - l] * ((h[i][r] - (l ? h[i][l - 1] : 0) + MODS[i]) % MODS[i])) % MODS[i];
        }
        return ret;
    }
};

vector<Hash> inp;

void init(){
    for(int i = 0; i < CNT_HASHES; i ++) pows[i][0] = 1;
    for(int i = 0; i < CNT_HASHES; i ++){
        for(int j = 1; j <= MAXN; j ++){
            pows[i][j] = (pows[i][j - 1] * BASE[i]) % MODS[i];
        }
    }
}

bool can(int len){
    map<vector<ll>, int> mp;
    for(int l = 0, r = len - 1; r < 2 * N; l ++, r ++){
        for(int i = 0; i < K; i ++){
            auto tmp = inp[i].get(l, r);
            mp[tmp] |= (1 << i);
            if(mp[tmp] == (1 << K) - 1) return true;
        }
    }
    return false;
}

int main(){
    init();
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    cin >> N >> K;
    inp = vector<Hash>(K);
    for(int i = 0; i < K; i ++){
        string t; cin >> t;
        t = t + t;
        inp[i] = Hash(t);
    }
    int l = 1, r = N, ans = 0;
    while(l <= r){
        int m = (l + r) / 2;
        if(can(m)){
            ans = m;
            l = m + 1;
        }
        else{
            r = m - 1;
        }
    }
    cout << ans << endl;
}
