#pragma optimization O2
#include<bits/stdc++.h>
#define ll long long
#define de(x) cout << #x << " = " << x << endl;
using namespace std;

const ll MOD = 1e9 + 7;
const ll BASE = 37;
const int MAXN = 2e5 + 5;
const int MAXK = 11;

ll N, K, pows[MAXN + 5], hashes[MAXK][MAXN];

void init(){
    pows[0] = 1;
    for(int i = 1; i <= MAXN; i ++) pows[i] = (pows[i - 1] * BASE) % MOD;
}

bool can(int len){
    unordered_map<int, int> mp;
    for(int l = 0, r = len - 1; r < 2 * N; l ++, r ++){ /// O(N * K)
        for(int i = 0; i < K; i ++){ /// O(K)
            ll got = (pows[MAXN - l] * (hashes[i][r] - (l ? hashes[i][l - 1] : 0) + MOD) % MOD) % MOD;
            mp[got] |= (1 << i);
            if(mp[got] == (1 << K) - 1) return true;
        }
    }
    return false;
}

int main(){
    init();
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    cin >> N >> K;
    for(int i = 0; i < K; i ++){ /// O(N * K)
        string t; cin >> t;
        for(int j = 0; j < 2 * N; j ++){ /// O(N)
            hashes[i][j] = ((j ? hashes[i][j - 1] : 0) + (pows[j] * (t[j % N] - 'a' + 1)) % MOD) % MOD;
        }
    }
    int l = 1, r = N, ans = 0;
    while(l <= r){ /// O(N * K * logN)
        int m = (l + r) / 2;
        if(can(m)){
            ans = m;
            l = m + 1;
        }
        else{
            r = m - 1;
        }
    }
    cout << ans << endl;
    /**
    for(int ans = N; ans >= 1; ans --){
        if(can(ans)){
            cout << ans << endl;
            return 0;
        }
    }
    */
}
/**
В студените нощи, когато пиян
сънят се търкаля по моя таван,
когато луната тъмнее от грях,
когато надвисва над мен моя страх,
обесен на острия ръб на нощта,
подавам ти своята бледа ръка,
на теб - непознатия - смугло красив
потаен и питомен, жаден и див,
едва деветнайсет години живял,
но всичко опитал и всичко видял,
подвластен на никого, ничий, сам свой,
но тръгнал към мен и истински мой.
Ръката ми - властната - жадно поел,
само с мен ще си толкова смел.
Ела! Ще измием луната от грях,
ще хвърлим трупа на умрелия страх,
ще пеем с тътнежния корабен глас
на морската нощ в добрия Бургас.
А после, когато тя тръгне назад
и слънцето бликне над нас благодат,
мечтата надраснал, усмихнат, смутен,
ще тръгнеш реален до мен в моя ден.
*/
