#include<bits/stdc++.h>
#define pb push_back
#define fr first
#define sc second
using namespace std;

template<class T> using matrix = vector<vector<T>>;

const int MAXN = 1e5 + 5;

struct unionfind{
    int N;
    vector<int> par, sz;
    unionfind() {}
    unionfind(int _N){
        N = _N;
        par = sz = vector<int>(N + 1);
        for(int i = 1; i <= N; i ++){
            par[i] = i;
            sz[i] = 1;
        }
    }
    int get_root(int u){
        return (u == par[u] ? u : par[u] = get_root(par[u]));
    }
    void join(int u, int v){
        u = get_root(u);
        v = get_root(v);
        if(sz[u] > sz[v]) swap(u, v);
        par[u] = v;
        sz[v] += sz[u];
    }
    int qry(int u, int v){
        return get_root(u) == get_root(v);
    }
};

int N, M, deg[MAXN];
vector<tuple<int, int, int>> edges;

int main(){
    cin >> N >> M;
    unionfind dsu(N);
    bool flag = true;
    for(int i = 1; i <= M; i ++){
        int u, v, t; cin >> u >> v >> t;
        edges.pb({u, v, t});
        if(t == 1){
            flag = false;
        }
    }
    vector<int> odd;
    for(int u = 1; u <= N; u ++){
        if(deg[u] % 2 == 1){
            odd.pb(u);
        }
    }
    if(odd.size() == 0){
        cout << "1\n";
    }
    else{
        if(flag) cout << "1\n";
        else cout << "-1\n";
    }
}
/**
6 8
1 3 2
1 4 1
3 4 1
2 4 2
2 3 1
3 5 2
5 6 1
2 6 1
*/
